"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _native = require("../../../utils/native");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class ConfirmationResult {
  /**
   *
   * @param auth
   * @param verificationId The phone number authentication operation's verification ID.
   */
  constructor(auth, verificationId) {
    _defineProperty(this, "_auth", void 0);

    _defineProperty(this, "_verificationId", void 0);

    this._auth = auth;
    this._verificationId = verificationId;
  }
  /**
   *
   * @param verificationCode
   * @return {*}
   */


  confirm(verificationCode) {
    return (0, _native.getNativeModule)(this._auth)._confirmVerificationCode(verificationCode).then(user => this._auth._setUser(user));
  }

  get verificationId() {
    return this._verificationId;
  }

}

exports.default = ConfirmationResult;