"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * 
 * AndroidInvitation representation wrapper
 */
class AndroidInvitation {
  constructor(invitation) {
    _defineProperty(this, "_additionalReferralParameters", void 0);

    _defineProperty(this, "_emailHtmlContent", void 0);

    _defineProperty(this, "_emailSubject", void 0);

    _defineProperty(this, "_googleAnalyticsTrackingId", void 0);

    _defineProperty(this, "_invitation", void 0);

    this._invitation = invitation;
  }
  /**
   *
   * @param additionalReferralParameters
   * @returns {Invitation}
   */


  setAdditionalReferralParameters(additionalReferralParameters) {
    this._additionalReferralParameters = additionalReferralParameters;
    return this._invitation;
  }
  /**
   *
   * @param emailHtmlContent
   * @returns {Invitation}
   */


  setEmailHtmlContent(emailHtmlContent) {
    this._emailHtmlContent = emailHtmlContent;
    return this._invitation;
  }
  /**
   *
   * @param emailSubject
   * @returns {Invitation}
   */


  setEmailSubject(emailSubject) {
    this._emailSubject = emailSubject;
    return this._invitation;
  }
  /**
   *
   * @param googleAnalyticsTrackingId
   * @returns {Invitation}
   */


  setGoogleAnalyticsTrackingId(googleAnalyticsTrackingId) {
    this._googleAnalyticsTrackingId = googleAnalyticsTrackingId;
    return this._invitation;
  }

  build() {
    return {
      additionalReferralParameters: this._additionalReferralParameters,
      emailHtmlContent: this._emailHtmlContent,
      emailSubject: this._emailSubject,
      googleAnalyticsTrackingId: this._googleAnalyticsTrackingId
    };
  }

}

exports.default = AndroidInvitation;