"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * 
 * AnalyticsParameters representation wrapper
 */
class AnalyticsParameters {
  constructor(link) {
    _defineProperty(this, "_campaign", void 0);

    _defineProperty(this, "_content", void 0);

    _defineProperty(this, "_link", void 0);

    _defineProperty(this, "_medium", void 0);

    _defineProperty(this, "_source", void 0);

    _defineProperty(this, "_term", void 0);

    this._link = link;
  }
  /**
   *
   * @param campaign
   * @returns {DynamicLink}
   */


  setCampaign(campaign) {
    this._campaign = campaign;
    return this._link;
  }
  /**
   *
   * @param content
   * @returns {DynamicLink}
   */


  setContent(content) {
    this._content = content;
    return this._link;
  }
  /**
   *
   * @param medium
   * @returns {DynamicLink}
   */


  setMedium(medium) {
    this._medium = medium;
    return this._link;
  }
  /**
   *
   * @param source
   * @returns {DynamicLink}
   */


  setSource(source) {
    this._source = source;
    return this._link;
  }
  /**
   *
   * @param term
   * @returns {DynamicLink}
   */


  setTerm(term) {
    this._term = term;
    return this._link;
  }

  build() {
    return {
      campaign: this._campaign,
      content: this._content,
      medium: this._medium,
      source: this._source,
      term: this._term
    };
  }

}

exports.default = AnalyticsParameters;