"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * 
 * AndroidParameters representation wrapper
 */
class AndroidParameters {
  constructor(link) {
    _defineProperty(this, "_fallbackUrl", void 0);

    _defineProperty(this, "_link", void 0);

    _defineProperty(this, "_minimumVersion", void 0);

    _defineProperty(this, "_packageName", void 0);

    this._link = link;
  }
  /**
   *
   * @param fallbackUrl
   * @returns {DynamicLink}
   */


  setFallbackUrl(fallbackUrl) {
    this._fallbackUrl = fallbackUrl;
    return this._link;
  }
  /**
   *
   * @param minimumVersion
   * @returns {DynamicLink}
   */


  setMinimumVersion(minimumVersion) {
    this._minimumVersion = minimumVersion;
    return this._link;
  }
  /**
   *
   * @param packageName
   * @returns {DynamicLink}
   */


  setPackageName(packageName) {
    this._packageName = packageName;
    return this._link;
  }

  build() {
    if ((this._fallbackUrl || this._minimumVersion) && !this._packageName) {
      throw new Error('AndroidParameters: Missing required `packageName` property');
    }

    return {
      fallbackUrl: this._fallbackUrl,
      minimumVersion: this._minimumVersion,
      packageName: this._packageName
    };
  }

}

exports.default = AndroidParameters;