"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _AnalyticsParameters = _interopRequireDefault(require("./AnalyticsParameters"));

var _AndroidParameters = _interopRequireDefault(require("./AndroidParameters"));

var _IOSParameters = _interopRequireDefault(require("./IOSParameters"));

var _ITunesParameters = _interopRequireDefault(require("./ITunesParameters"));

var _NavigationParameters = _interopRequireDefault(require("./NavigationParameters"));

var _SocialParameters = _interopRequireDefault(require("./SocialParameters"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class DynamicLink {
  constructor(link, dynamicLinkDomain) {
    _defineProperty(this, "_analytics", void 0);

    _defineProperty(this, "_android", void 0);

    _defineProperty(this, "_dynamicLinkDomain", void 0);

    _defineProperty(this, "_ios", void 0);

    _defineProperty(this, "_itunes", void 0);

    _defineProperty(this, "_link", void 0);

    _defineProperty(this, "_navigation", void 0);

    _defineProperty(this, "_social", void 0);

    this._analytics = new _AnalyticsParameters.default(this);
    this._android = new _AndroidParameters.default(this);
    this._dynamicLinkDomain = dynamicLinkDomain;
    this._ios = new _IOSParameters.default(this);
    this._itunes = new _ITunesParameters.default(this);
    this._link = link;
    this._navigation = new _NavigationParameters.default(this);
    this._social = new _SocialParameters.default(this);
  }

  get analytics() {
    return this._analytics;
  }

  get android() {
    return this._android;
  }

  get ios() {
    return this._ios;
  }

  get itunes() {
    return this._itunes;
  }

  get navigation() {
    return this._navigation;
  }

  get social() {
    return this._social;
  }

  build() {
    if (!this._link) {
      throw new Error('DynamicLink: Missing required `link` property');
    } else if (!this._dynamicLinkDomain) {
      throw new Error('DynamicLink: Missing required `dynamicLinkDomain` property');
    }

    return {
      analytics: this._analytics.build(),
      android: this._android.build(),
      dynamicLinkDomain: this._dynamicLinkDomain,
      ios: this._ios.build(),
      itunes: this._itunes.build(),
      link: this._link,
      navigation: this._navigation.build(),
      social: this._social.build()
    };
  }

}

exports.default = DynamicLink;