"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * 
 * IOSParameters representation wrapper
 */
class IOSParameters {
  constructor(link) {
    _defineProperty(this, "_appStoreId", void 0);

    _defineProperty(this, "_bundleId", void 0);

    _defineProperty(this, "_customScheme", void 0);

    _defineProperty(this, "_fallbackUrl", void 0);

    _defineProperty(this, "_iPadBundleId", void 0);

    _defineProperty(this, "_iPadFallbackUrl", void 0);

    _defineProperty(this, "_link", void 0);

    _defineProperty(this, "_minimumVersion", void 0);

    this._link = link;
  }
  /**
   *
   * @param appStoreId
   * @returns {DynamicLink}
   */


  setAppStoreId(appStoreId) {
    this._appStoreId = appStoreId;
    return this._link;
  }
  /**
   *
   * @param bundleId
   * @returns {DynamicLink}
   */


  setBundleId(bundleId) {
    this._bundleId = bundleId;
    return this._link;
  }
  /**
   *
   * @param customScheme
   * @returns {DynamicLink}
   */


  setCustomScheme(customScheme) {
    this._customScheme = customScheme;
    return this._link;
  }
  /**
   *
   * @param fallbackUrl
   * @returns {DynamicLink}
   */


  setFallbackUrl(fallbackUrl) {
    this._fallbackUrl = fallbackUrl;
    return this._link;
  }
  /**
   *
   * @param iPadBundleId
   * @returns {DynamicLink}
   */


  setIPadBundleId(iPadBundleId) {
    this._iPadBundleId = iPadBundleId;
    return this._link;
  }
  /**
   *
   * @param iPadFallbackUrl
   * @returns {DynamicLink}
   */


  setIPadFallbackUrl(iPadFallbackUrl) {
    this._iPadFallbackUrl = iPadFallbackUrl;
    return this._link;
  }
  /**
   *
   * @param minimumVersion
   * @returns {DynamicLink}
   */


  setMinimumVersion(minimumVersion) {
    this._minimumVersion = minimumVersion;
    return this._link;
  }

  build() {
    if ((this._appStoreId || this._customScheme || this._fallbackUrl || this._iPadBundleId || this._iPadFallbackUrl || this._minimumVersion) && !this._bundleId) {
      throw new Error('IOSParameters: Missing required `bundleId` property');
    }

    return {
      appStoreId: this._appStoreId,
      bundleId: this._bundleId,
      customScheme: this._customScheme,
      fallbackUrl: this._fallbackUrl,
      iPadBundleId: this._iPadBundleId,
      iPadFallbackUrl: this._iPadFallbackUrl,
      minimumVersion: this._minimumVersion
    };
  }

}

exports.default = IOSParameters;